/******************************************************************************/
/*			  PhysTech, Inc - prime.c			      */
/*	Copyright (C) Feb.20, 1997 Sergei Viznyuk <phystech@hotmail.com>      */
/*									      */
/*	This code is provided without warranty, without even the	      */
/*  implied warranty of merchantability or fitness for a particular purpose.  */
/*******************************************************************************

prime.c

Prints prime numbers.
Usage: prime [-o output_file] [<max> [<min>]]

*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>

#ifndef ULLONG_MAX
#define ULLONG_MAX   18446744073709551615ULL
#endif

int main(argn,argc)
int argn;
char *argc[];
{
  FILE *f=stdout;
  unsigned char *c;
  register unsigned long long i=1ULL,min=2ULL,max=ULLONG_MAX;

  while ( (c=argc[i++]) )
    if ( *c=='-' )
      if ( *++c=='o' )
	if ( !(f=fopen(argc[i],"w")) )
	  { fprintf(stderr,"%s\n",strerror(errno)); return errno; }
	else i++;
      else goto er;
    else
      if ( isdigit(*c) )
	if ( max<ULLONG_MAX ) if ( (min=strtoull(c,NULL,0)) ); else goto er;
	else max=strtoull(c,NULL,0);
      else goto er;
  if ( max < min ) goto er;
  while ( min < 4ULL )
    if ( min > max ) return 0; else fprintf(f,"%llu\n",min++);
  if ( min%2ULL ) min-=2; else min--;
  while ( (min+=2ULL) <= max )
    if ( !((min+1ULL)%6ULL)  || !((min-1ULL)%6ULL) )
      { for (i=3ULL;i*i<min;i+=2) if ( ! (min%i) ) break;
	if ( i*i > min ) fprintf(f,"%llu\n",min);
      }

  return 0;
er:
  fprintf(stderr,"Usage: prime [-o output_file] [<max> [<min>]]\n");
  return 1;
}
